program DesktopMixer;

uses
  Forms, SysUtils, Windows, Graphics, Dialogs, Classes, Messages, System,
  Mw in 'Mw.pas' {Form1},
  dt_options in 'dt_options.pas' {Form2};

{$E SCR}
{$R *.RES}

var
  DemoWnd: HWnd;
  MyRect: TRect;
  MyCanvas: TCanvas;
  MyMod,MySem: THandle;
  SysDir,Arg1,Arg2: string;
  MyBkgBitmap,InMemBitmap: TBitmap;
  ScrWidth,ScrHeight,NewLen: integer;

  PwdFunc: function (a: PChar; ParentHandle: THandle; b, c: integer): integer; stdcall;

  IsPreview         : Boolean;
  MoveCounter       : Integer;
  QuitSaver         : Boolean;
  PreviewWindow     : hWnd;
  MaxX,MaxY         : Integer;
  RoundedRectangles : Boolean;
  SolidColors       : Boolean;

begin
 Application.Title:='Desktop Mixer';

 OutDc:=GetDc(0);
 Arg1:=UpperCase(ParamStr(1));
 Arg2:=UpperCase(ParamStr(2));

 if (Copy(Arg1,1,2) = '/A') or (Copy(Arg1,1,2) = '-A') or
    (Copy(Arg1,1,1) = 'A')
 then SSMode:=ssSetPwd;

 if (Copy(Arg1,1,2) = '/P') or (Copy(Arg1,1,2) = '-P') or
    (Copy(Arg1,1,1) = 'P')
 then SSMode:=ssPreview;

 if (Copy(Arg1,1,2) = '/C')or (Copy(Arg1,1,2) = '-C') or
    (Copy(Arg1,1,1) = 'C') or (Arg1 = '')
 then SSMode:=ssConfig;

 if SSMode = ssSetPwd
 then
  begin
   SetLength(SysDir,MAX_PATH);
   NewLen:=GetSystemDirectory(PChar(SysDir),MAX_PATH);
   SetLength(SysDir,NewLen);
   if (Length(SysDir)>0) and (SysDir[Length(SysDir)]<>'\')
   then SysDir:= SysDir+'\';
   MyMod:=LoadLibrary(PChar(SysDir+'MPR.DLL'));

   if MyMod<>0
   then
    begin
     PwdFunc:=GetProcAddress(MyMod,'PwdChangePasswordA');
     if Assigned(PwdFunc)
     then PwdFunc('SCRSAVE',StrToInt(Arg2),0,0);
     FreeLibrary(MyMod);
    end;
   Halt;
  end;

 if SSMode = ssPreview
 then
  begin
   DemoWnd:=StrToInt(Arg2);

   while not IsWindowVisible(DemoWnd) do
    Application.ProcessMessages;

   GetWindowRect(DemoWnd,MyRect);
   ScrWidth := MyRect.Right-MyRect.Left+1;
   ScrHeight := MyRect.Bottom-MyRect.Top+1;
   MyCanvas := TCanvas.Create;
   MyCanvas.Handle := GetDC(DemoWnd);

   MyCanvas.Brush.Color := clBlack;
   MyCanvas.Font.Color := clMaroon;
   MyCanvas.Font.Name := 'Verdana';
   MyCanvas.Font.Style := MyCanvas.Font.Style + [fsBold];

   while IsWindowVisible(DemoWnd) do
    begin
     MyCanvas.Textout(30,30,'DMixer');
    end;

   MyCanvas.Free;
   Halt;
  end;

  if SSMode = ssConfig
  then
   begin
    Application.Initialize;
    // Application.CreateForm(TForm1, Form1);    
    Application.CreateForm(TForm2, Form2);
    Application.Run;
   end
  else
   begin
    MySem:=CreateSemaphore(nil,0,1,'DMixerSaverSemaphore');
    if (MySem<>0) and (GetLastError=ERROR_ALREADY_EXISTS)
    then
     begin
      CloseHandle(MySem);
      Exit;
     end;
    Application.Initialize;
    Application.CreateForm(TForm1, Form1);
    Application.Run;
   end;  
end.
