unit Mw;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, IniFiles, GdipApi, GdipClass;

type TSSMode = (ssSetPwd,ssPreview,ssConfig,ssRun);
const
  SSMode  : TSSMode = ssRun;
  TestMode: Boolean = true;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Image1: TImage;
    Image2: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDestroy(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    vDString   : string;
    vDFntName  : string;
    vDFntSize  : single;
    vDBrdSize  : single;
    vDBorderCol: TGPColor;
    vDInnerCol : TGPColor;
    vDCQ       : CompositingQuality;
    vDSM       : SmoothingMode;
    vDFonCol   : TGPColor;

    procedure Draw_GDIText;
  end;

var
  Form1: TForm1;
  OutDc: THandle;
  Delta: integer; //        (  2*n)
  fname,ftext: string;
  ini_settings: TIniFile;
  DesktopBitmap,redRect: TBitmap;
  exit_mcl,exit_kp,showtime: boolean;
  gx,gy,rW,rH,foncol,bordercol,innercol,fontsize: integer;

  str_al,lstr_al: TStringAlignment;

implementation

uses dt_options;

{$R *.DFM}

procedure TForm1.Draw_GDIText;
var
 DPen: TGPPen;
 Layout: TGPRect;
 Drawer: TGPGraphics;
 DBrush: TGPSolidBrush;
 DFntFam: TGPFontFamily;
 DPath: TGPGraphicsPath;
 DFntFmt: TGPStringFormat;
begin
 if showtime=false
 then vDString:=ftext
 else vDString:=TimeToStr(Time);

 vdBrdSize:=2;
 vDFntName:=fname;
 vDFntSize:=fontsize;

 vDCQ:=CompositingQualityHighQuality;
 vDSM:=SmoothingModeAntiAlias;

 // Couleur du contour
 vDBorderCol:=ARGBMake(255,
                       GetRValue(bordercol),
                       GetGValue(bordercol),
                       GetBValue(bordercol));
 // Couleur du texte
 vdInnerCol:=ARGBMake(255,
                       GetRValue(innercol),
                       GetGValue(innercol),
                       GetBValue(innercol));
 // FonColor
 vDFonCol:=ARGBMake(255,
                       GetRValue(foncol),
                       GetGValue(foncol),
                       GetBValue(foncol));

 str_al:=StringAlignmentCenter;
 lstr_al:=StringAlignmentCenter;

 ////////////////////////////////////////

 Image2.Picture.Bitmap.Assign(redRect);

 Layout.X:=0;
 Layout.Y:=0;
 Layout.Width:=redRect.Width;
 Layout.Height:=redRect.Height;

 Drawer:=TGPGraphics.Create(Image2.Canvas.Handle);
 Drawer.SetCompositingQuality(vDCQ);
 Drawer.SetSmoothingMode(vdSM);

 DPath:=TGPGraphicsPath.Create;
 DPen:=TGPPen.Create(vDBorderCol, vDBrdSize);
 DBrush:=TGPSolidBrush.Create(vDInnerCol);

 DFntFam:=TGPFontFamily.Create(vDFntName);

 DFntFmt:=TGPStringFormat.Create;
 if false
 then
  begin
   DFntFmt.SetAlignment(StringAlignmentNear);
   DFntFmt.SetLineAlignment(StringAlignmentNear);
  end
 else
  begin
   DFntFmt.SetAlignment(str_al);
   DFntFmt.SetLineAlignment(lstr_al);
  end;

 Drawer.Clear(vDFonCol);

 DPath.Reset;
 DPath.AddString(vDString, Length(vDString), DFntFam, FontStyleRegular, vDFntSize, Layout, DFntFmt);

 Drawer.DrawPath(DPen, DPath);
 Drawer.FillPath(DBrush, DPath);

 DFntFmt.Free;
 DFntFam.Free;
 DBrush.Free;
 DPen.Free;
 DPath.Free;
 Drawer.Free;
end;

///////////////////////////////////////////////////////////////////////////////

procedure InitScreen;
var
 i: integer;
begin
 //   
 DesktopBitmap:=TBitmap.Create;
 with DesktopBitmap do
  begin
   Width:=Screen.Width;
   Height:=Screen.Height;
  end;
 BitBlt(DesktopBitmap.Canvas.Handle,
                 0,0,Screen.Width,Screen.Height,
                            GetDC(GetDesktopWindow),0,0,SrcCopy);
 Form1.Image1.Picture.Bitmap:=DesktopBitmap;
 //   redRect
 Randomize;
 gx:=Trunc(Random*Delta);
 gy:=Trunc(Random*Delta);
 Form1.Image1.Canvas.CopyRect(
            Rect(rW*gx, rH*gy, rW*gx+rW, rH*gy+rH),
                                 redRect.Canvas, Rect(0,0,rW,rH));
 //  
 for i:=0 to DELTA-1 do
  begin
   Form1.Image1.Canvas.MoveTo(rW*i,0);
   Form1.Image1.Canvas.LineTo(rW*i,Screen.Height);
   Form1.Image1.Canvas.MoveTo(0, rH*i);
   Form1.Image1.Canvas.LineTo(Screen.Width, rH*i);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 ShowCursor(false);
 SystemParametersInfo(SPI_SCREENSAVERRUNNING,1,0,0);

 ini_settings:=TIniFile.Create(ExtractFilePath(Application.Exename)+'DesktopMixer.ini');

 exit_kp:=ini_settings.ReadBool('Options','ExitOnEscape',true);
 exit_mcl:=ini_settings.ReadBool('Options','ExitOnMouseClick',false);
 fname:=ini_settings.ReadString('Options','FontName','Arial');
 foncol:=ini_settings.ReadInteger('Options','FonColor',255);
 bordercol:=ini_settings.ReadInteger('Options','BorderColor',10344892);
 innercol:=ini_settings.ReadInteger('Options','InnerColor',0);

 fontsize:=ini_settings.ReadInteger('Options','FontSize',8);
 ftext:=ini_settings.ReadString('Options','Text','www.delphisources.ru');
 showtime:=ini_settings.ReadBool('Options','ShowTime',true);

 Delta:=8; // Trunc(Power(2,3));
 rW:=Screen.Width div Delta;
 rH:=Screen.Height div Delta;
 redRect:=TBitmap.Create;

 with redRect do
  begin
   Width:=rW;
   Height:=rH;
   Canvas.Brush.Color:=clBlack;
   // Canvas.Brush.Style:=bssolid;
   // Canvas.Rectangle(0,0,rW+1,rH+1);
  end;

 Draw_GDIText;
 redRect.Assign(Image2.Picture.Bitmap);
 redRect.Canvas.Brush.Style:=bsClear;
 redRect.Canvas.Rectangle(0,0,rW+1,rH+1);

 Timer1.Enabled:=false;
 Image1.Align:=alClient;
 Visible:=false;
 BorderStyle:=bsNone;
 Top:=0;
 Left:=0;
 Width:=Screen.Width;
 Height:=Screen.Height;

 InitScreen;

 Visible:=true;
 // -
 Timer1.Interval:=ini_settings.ReadInteger('Options','MixSpeed',500);
 //   DrawScreen
 Timer1.Enabled:=true;
end;

procedure DrawScreen;
var
 r1,r2: TRect;
 Direction: integer;
begin
 r1:=Rect(rW*gx, rH*gy, rW*gx+rW, rH*gy+rH);
 Direction:=Trunc(Random*4);

 case Direction of
   0: gx:=Abs((gx+1) mod Delta); // 
   1: gx:=Abs((gx-1) mod Delta); // 
   2: gy:=Abs((gy+1) mod Delta); // 
   3: gy:=Abs((gy-1) mod Delta); // 
 end;

 r2:=Rect(rW*gx , rH*gy,  rW*gx+rW  , rH*gy+rH);
 with Form1.Image1.Canvas do
  begin
   CopyRect(r1, Form1.Image1.Canvas, r2);
   CopyRect(r2, redRect.Canvas, redRect.Canvas.ClipRect);
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 DrawScreen;

 if showtime=true
 then
  begin
   Draw_GDIText;
   redRect.Assign(Image2.Picture.Bitmap);
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 SystemParametersInfo(SPI_SCREENSAVERRUNNING,0,0,0);
 Application.Terminate;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if exit_kp=true
 then
  // if key=VK_ESCAPE
  // then
   begin
    ShowCursor(true);
    Close;
   end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 redRect.Free;
 ini_settings.Free;
 DesktopBitmap.Free;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if exit_mcl=true
 then
  begin
   ShowCursor(true);
   Close;
  end;
end;

end.
